2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by at least coreutils, idutils, CPPI, Bison, and Autoconf.
5 ## Copyright (C) 2001-2009 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # Do not save the original name or timestamp in the .tar.gz file.
25 # Use --rsyncable if available.
27 $(shell gzip
--help
2>/dev
/null|grep rsyncable
>/dev
/null
&& echo
--rsyncable
)
28 GZIP_ENV
= '--no-name --best $(gzip_rsyncable)'
32 VC-tag
= git tag
-s
-m
'$(VERSION)'
34 VC_LIST
= $(srcdir)/build-aux
/vc-list-files
37 $(VC_LIST
) | if
test -f .x-
$@
; then grep
-vEf .x-
$@
; else grep
-v ChangeLog
; fi
39 ifeq ($(origin prev_version_file
), undefined
)
40 prev_version_file
= $(srcdir)/.prev-version
43 PREV_VERSION
:= $(shell cat
$(prev_version_file
))
44 VERSION_REGEXP
= $(subst .
,\.
,$(VERSION
))
45 PREV_VERSION_REGEXP
= $(subst .
,\.
,$(PREV_VERSION
))
48 this-vc-tag
= v
$(VERSION
)
49 this-vc-tag-regexp
= v
$(VERSION_REGEXP
)
51 tag-package
= $(shell echo
"$(PACKAGE)" | tr
'[:lower:]' '[:upper:]')
52 tag-this-version
= $(subst .
,_
,$(VERSION
))
53 this-vc-tag
= $(tag-package
)-$(tag-this-version
)
54 this-vc-tag-regexp
= $(this-vc-tag
)
56 my_distdir
= $(PACKAGE
)-$(VERSION
)
58 # Old releases are stored here.
59 release_archive_dir ?
= ..
/release
61 # Prevent programs like 'sort' from considering distinct strings to be equal.
62 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
69 # Collect the names of rules starting with `sc_'.
70 syntax-check-rules
:= $(shell sed
-n
's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
71 $(srcdir)/$(ME
) $(srcdir)/cfg.mk
)
72 .PHONY
: $(syntax-check-rules
)
74 local-checks-available
= \
75 patch-check
$(syntax-check-rules
) \
76 makefile-check check-AUTHORS
77 .PHONY
: $(local-checks-available
)
79 # Arrange to print the name of each syntax-checking rule just before running it.
80 $(syntax-check-rules
): %: %.m
81 $(patsubst %, %.m
, $(syntax-check-rules
)):
82 @echo
$(patsubst sc_
%.m
, %, $@
)
84 local-check
:= $(filter-out $(local-checks-to-skip
), $(local-checks-available
))
86 syntax-check
: $(local-check
)
87 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
88 # $$(find -type f -name '*.[chly]') && \
89 # { echo '$(ME): found conditional include' 1>&2; \
92 # grep -nE '^# *include <(string|stdlib)\.h>' \
93 # $(srcdir)/{lib,src}/*.[chy] && \
94 # { echo '$(ME): FIXME' 1>&2; \
96 # FIXME: don't allow `#include .strings\.h' anywhere
98 # By default, _prohibit_regexp does not ignore case.
100 _ignore_case
= $$(test -n
"$$ignore_case" && echo
-i ||
:)
102 # There are many rules below that prohibit constructs in this package.
103 # If the offending construct can be matched with a grep-E-style regexp,
104 # use this macro. The shell variables "re" and "msg" must be defined.
105 define _prohibit_regexp
106 dummy
=; : so we do not need a semicolon before each use
; \
107 test "x$$re" != x ||
{ echo
'$(ME): re not defined' 1>&2; exit
1; }; \
108 test "x$$msg" != x ||
{ echo
'$(ME): msg not defined' 1>&2; exit
1; };\
109 grep
$(_ignore_case
) -nE
"$$re" $$($(VC_LIST_EXCEPT
)) && \
110 { echo
'$(ME): '"$$msg" 1>&2; exit
1; } ||
:
113 sc_avoid_if_before_free
:
114 @
$(srcdir)/build-aux
/useless-if-before-free \
115 $(useless_free_options
) \
116 $$($(VC_LIST_EXCEPT
)) && \
117 { echo
'$(ME): found useless "if" before "free" above' 1>&2; \
120 sc_cast_of_argument_to_free
:
121 @re
='\<free *\( *\(' msg
='don'\''t cast free argument' \
124 sc_cast_of_x_alloc_return_value
:
125 @re
='\*\) *x(m|c|re)alloc\>' \
126 msg
='don'\''t cast x*alloc return value' \
129 sc_cast_of_alloca_return_value
:
130 @re
='\*\) *alloca\>' msg
='don'\''t cast alloca return value' \
134 @re
='[ ] ' msg
='found SPACE-TAB sequence; remove the SPACE' \
137 # Don't use *scanf or the old ato* functions in `real' code.
138 # They provide no error checking mechanism.
139 # Instead, use strto* functions.
140 sc_prohibit_atoi_atof
:
141 @re
='\<([fs]?scanf|ato([filq]|ll)) *\(' \
142 msg
='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
145 # Use STREQ rather than comparing strcmp == 0, or != 0.
147 @grep
-nE
'! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
148 $$($(VC_LIST_EXCEPT
)) \
149 | grep
-vE
':# *define STREQ\(' && \
150 { echo
'$(ME): use STREQ in place of the above uses of str''cmp' \
153 # Using EXIT_SUCCESS as the first argument to error is misleading,
154 # since when that parameter is 0, error does not exit. Use `0' instead.
155 sc_error_exit_success
:
156 @grep
-nE
'error \(EXIT_SUCCESS,' \
157 $$($(VC_LIST_EXCEPT
) | grep
-E
'\.[chly]$$') && \
158 { echo
'$(ME): found error (EXIT_SUCCESS' 1>&2; exit
1; } ||
:
160 # `FATAL:' should be fully upper-cased in error messages
161 # `WARNING:' should be fully upper-cased, or fully lower-cased
162 sc_error_message_warn_fatal
:
163 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
164 | grep
-E
'"Warning|"Fatal|"fatal' && \
165 { echo
'$(ME): use FATAL, WARNING or warning' 1>&2; \
168 # Error messages should not start with a capital letter
169 sc_error_message_uppercase
:
170 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
172 | grep
-vE
'"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
173 { echo
'$(ME): found capitalized error message' 1>&2; \
176 # Error messages should not end with a period
177 sc_error_message_period
:
178 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
179 | grep
-E
'[^."]\."' && \
180 { echo
'$(ME): found error message ending in period' 1>&2; \
184 @re
=file
''system ignore_case
=1 \
185 msg
='found use of "file''system"; spell it "file system"' \
188 # Don't use cpp tests of this symbol. All code assumes config.h is included.
189 sc_prohibit_have_config_h
:
190 @grep
-n
'^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT
)) && \
191 { echo
'$(ME): found use of HAVE''_CONFIG_H; remove' \
194 # Nearly all .c files must include <config.h>.
196 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
197 grep
-L
'^# *include <config\.h>' \
198 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$') \
200 { echo
'$(ME): the above files do not include <config.h>' \
201 1>&2; exit
1; } ||
:; \
205 # You must include <config.h> before including any other header file.
206 sc_require_config_h_first
:
207 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
209 for i in
$$($(VC_LIST_EXCEPT
) | grep
'\.c$$'); do \
210 grep
'^# *include\>' $$i | sed
1q \
211 | grep
'^# *include <config\.h>' > /dev
/null \
212 ||
{ echo
$$i; fail
=1; }; \
215 { echo
'$(ME): the above files include some other header' \
216 'before <config.h>' 1>&2; exit
1; } ||
:; \
220 sc_prohibit_HAVE_MBRTOWC
:
221 @re
='\bHAVE_MBRTOWC\b' msg
="do not use $$re; it is always defined" \
224 # To use this "command" macro, you must first define two shell variables:
225 # h: the header, enclosed in <> or ""
226 # re: a regular expression that matches IFF something provided by $h is used.
227 define _header_without_use
228 h_esc
=`echo "$$h"|sed 's/\./\\./g'`; \
229 if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
230 files
=$$(grep
-l
'^# *include '"$$h_esc" \
231 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')) && \
232 grep
-LE
"$$re" $$files | grep .
&& \
233 { echo
"$(ME): the above files include $$h but don't use it" \
234 1>&2; exit
1; } ||
:; \
239 # Prohibit the inclusion of assert.h without an actual use of assert.
240 sc_prohibit_assert_without_use
:
241 @h
='<assert.h>' re
='\<assert *\(' $(_header_without_use
)
243 # Prohibit the inclusion of getopt.h without an actual use.
244 sc_prohibit_getopt_without_use
:
245 @h
='<getopt.h>' re
='\<getopt(_long)? *\(' $(_header_without_use
)
247 # Don't include quotearg.h unless you use one of its functions.
248 sc_prohibit_quotearg_without_use
:
249 @h
='"quotearg.h"' re
='\<quotearg(_[^ ]+)? *\(' $(_header_without_use
)
251 # Don't include quote.h unless you use one of its functions.
252 sc_prohibit_quote_without_use
:
253 @h
='"quote.h"' re
='\<quote(_n)? *\(' $(_header_without_use
)
255 # Don't include this header unless you use one of its functions.
256 sc_prohibit_long_options_without_use
:
257 @h
='"long-options.h"' re
='\<parse_long_options *\(' \
258 $(_header_without_use
)
260 # Don't include this header unless you use one of its functions.
261 sc_prohibit_inttostr_without_use
:
262 @h
='"inttostr.h"' re
='\<(off|[iu]max|uint)tostr *\(' \
263 $(_header_without_use
)
265 # Don't include this header unless you use one of its functions.
266 sc_prohibit_error_without_use
:
268 re
='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
269 $(_header_without_use
)
271 sc_prohibit_safe_read_without_use
:
272 @h
='"safe-read.h"' re
='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
273 $(_header_without_use
)
275 sc_prohibit_argmatch_without_use
:
277 re
='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
278 $(_header_without_use
)
280 sc_prohibit_root_dev_ino_without_use
:
281 @h
='"root-dev-ino.h"' \
282 re
='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
283 $(_header_without_use
)
285 # Prohibit the inclusion of c-ctype.h without an actual use.
286 ctype_re
= isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
287 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
288 sc_prohibit_c_ctype_without_use
:
289 @h
='[<"]c-ctype.h[">]' re
='\<c_($(ctype_re)) *\(' $(_header_without_use
)
292 _sp
= $(_empty
) $(_empty
)
293 # The following list was generated by running:
294 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
295 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
297 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
298 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
299 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
300 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
301 _sig_function_re
= $(subst $(_sp
),|
,$(strip $(_sig_functions
)))
302 # The following were extracted from "man signal.h" manually.
303 _sig_types_and_consts
= \
304 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
305 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
306 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
307 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
308 sigstack sigval stack_t ucontext_t
309 # generated via this:
310 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
312 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
313 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
314 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
315 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
316 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
317 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
318 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
320 _sig_syms_re
= $(subst $(_sp
),|
,$(strip $(_sig_names
) $(_sig_types_and_consts
)))
322 # Prohibit the inclusion of signal.h without an actual use.
323 sc_prohibit_signal_without_use
:
325 re
='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
326 $(_header_without_use
)
329 @re
='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
330 msg
='do not use HAVE''_FCNTL_H or O'_NDELAY \
333 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
335 # Each nonempty ChangeLog line must start with a year number, or a TAB.
337 @if
$(VC_LIST_EXCEPT
) | grep
-l
'^ChangeLog$$' >/dev
/null
; then \
339 $$($(VC_LIST_EXCEPT
) | grep
'^ChangeLog$$') && \
340 { echo
'$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
344 # Ensure that each .c file containing a "main" function also
345 # calls set_program_name.
347 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
348 files
=$$(grep
-l
'^main *(' $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')); \
349 grep
-LE
'set_program_name *\(m?argv\[0\]\);' $$files \
351 { echo
'$(ME): the above files do not call set_program_name' \
352 1>&2; exit
1; } ||
:; \
356 # Require that the final line of each test-lib.sh-using test be this one:
358 # Note: this test requires GNU grep's --label= option.
359 sc_require_test_exit_idiom
:
360 @if
test -f
$(srcdir)/tests
/test-lib.sh
; then \
362 for i in
$$(grep
-l
-F
/..
/test-lib.sh
$$($(VC_LIST
) tests
)); do \
363 tail
-n1
$$i | grep
'^Exit \$$fail$$' > /dev
/null \
364 && : ||
{ die
=1; echo
$$i; } \
367 { echo
1>&2 '$(ME): the final line in each of the above is not:'; \
368 echo
1>&2 'Exit $$fail'; \
373 @re
='\<the ''the\>' \
374 ignore_case
=1 msg
='found use of "the ''the";' \
379 msg
='found trailing blank(s)' \
382 # Match lines like the following, but where there is only one space
383 # between the options and the description:
384 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
385 longopt_re
= --[a-z
][0-9A-Za-z-
]*(\
[?
=[0-9A-Za-z-
]*\
]?
)?
386 sc_two_space_separator_in_usage
:
387 @grep
-nE
'^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
388 $$($(VC_LIST_EXCEPT
)) && \
389 { echo
"$(ME): help2man requires at least two spaces between"; \
390 echo
"$(ME): an option and its description"; \
393 # Look for diagnostics that aren't marked for translation.
394 # This won't find any for which error's format string is on a separate line.
395 sc_unmarked_diagnostics
:
397 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT
)) \
398 | grep
-v
'_''(' && \
399 { echo
'$(ME): found unmarked diagnostic(s)' 1>&2; \
402 # Avoid useless parentheses like those in this example:
403 # #if defined (SYMBOL) || defined (SYM2)
404 sc_useless_cpp_parens
:
405 @grep
-n
'^# *if .*defined *(' $$($(VC_LIST_EXCEPT
)) && \
406 { echo
'$(ME): found useless parentheses in cpp directive' \
409 # Require the latest GPL.
411 @re
='either ''version [^3]' msg
='GPL vN, N!=3' \
415 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
417 sc_prohibit_cvs_keyword
:
418 @re
='\$$($(cvs_keywords))\$$' \
419 msg
='do not use CVS keyword expansion' \
422 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
423 # This is a bit of a kludge, since it prevents use of the string
424 # even in comments, but for now it does the job with no false positives.
425 sc_prohibit_stat_st_blocks
:
426 @re
='[.>]st_blocks' msg
='do not use st_blocks; use ST_NBLOCKS' \
429 # Make sure we don't define any S_IS* macros in src/*.c files.
430 # They're already defined via gnulib's sys/stat.h replacement.
431 sc_prohibit_S_IS_definition
:
432 @re
='^ *# *define *S_IS' \
433 msg
='do not define S_IS* macros; include <sys/stat.h>' \
436 # Each program that uses proper_name_utf8 must link with
437 # one of the ICONV libraries.
438 sc_proper_name_utf8_requires_ICONV
:
439 @progs
=$$(grep
-l
'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT
)));\
440 if
test "x$$progs" != x
; then \
442 for p in
$$progs; do \
443 dir=$$(dirname
"$$p"); \
444 base
=$$(basename "$$p" .c
); \
445 grep
"$${base}_LDADD.*ICONV)" $$dir/Makefile.am
> /dev
/null \
446 ||
{ fail
=1; echo
1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
449 { echo
1>&2 '$(ME): the above do not link with any ICONV library'; \
453 # Warn about "c0nst struct Foo const foo[]",
454 # but not about "char const *const foo" or "#define const const".
456 @re
='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
457 msg
='redundant "const" in declarations' \
460 sc_const_long_option
:
461 @grep
'^ *static.*struct option ' $$($(VC_LIST_EXCEPT
)) \
462 | grep
-Ev
'const struct option|struct option const' && { \
463 echo
1>&2 '$(ME): add "const" to the above declarations'; \
467 $$(sed
-n
'/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
469 | grep
-v
'^Copyright .*Free Software' \
473 # Ensure that we don't accidentally insert an entry into an old NEWS block.
475 @if
test -f
$(srcdir)/NEWS
; then \
476 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
477 { echo
'$(ME): you have modified old NEWS' 1>&2; exit
1; }; \
480 # Update the hash stored above. Do this after each release and
481 # for any corrections to old entries.
482 update-NEWS-hash
: NEWS
483 perl
-pi
-e
's/^(old_NEWS_hash = ).*/$${1}'"$(NEWS_hash)/" \
486 epoch_date
= 1970-01-01 00:00:00.000000000 +0000
487 # Ensure that the c99-to-c89 patch applies cleanly.
489 rm -rf src-c89
$@
.1 $@
.2
490 cp
-a
$(srcdir)/src src-c89
491 if
test "x$(srcdir)" != x.
; then \
492 cp
-a src
/* src-c89
; \
493 dotfiles
=`ls src/.[!.]* 2>/dev/null`; \
494 test -z
"$$dotfiles" || cp
-a src
/.
[!.
]* src-c89
; \
496 (cd src-c89
; patch
-p1
-V never
--fuzz
=0) < $(srcdir)/src
/c99-to-c89.diff \
498 if
test "$(REGEN_PATCH)" = yes
; then \
499 diff
-upr
$(srcdir)/src src-c89 | sed
's,$(srcdir)/src-c89/,src/,' \
500 | grep
-vE
'^(Only in|File )' \
501 | perl
-pe
's/^((?:\+\+\+|---) \S+\t).*/$${1}$(epoch_date)/;' \
504 grep
-v
'^patching file ' $@
.1 > $@
.2 ||
:
505 msg
=ok
; test -s
$@
.2 && msg
='fuzzy patch' ||
: ; \
506 rm -f src-c89
/*.o || msg
='rm failed'; \
507 $(MAKE
) -C src-c89 CFLAGS
='-Wdeclaration-after-statement -Werror' \
508 || msg
='compile failure with extra options'; \
509 test "$$msg" = ok
&& rm -rf src-c89
$@
.1 $@
.2 || echo
"$$msg" 1>&2; \
515 # Ensure that we use only the standard $(VAR) notation,
516 # not @...@ in Makefile.am, now that we can rely on automake
517 # to emit a definition for each substituted variable.
518 # We use perl rather than "grep -nE ..." to exempt a single
519 # use of an @...@-delimited variable name in src/Makefile.am.
521 @perl
-ne
'/\@[A-Z_0-9]+\@/ && !/^cu_install_program =/' \
522 -e
'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
523 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^|/)Makefile\.am$$') \
524 && { echo
'$(ME): use $$(...), not @...@' 1>&2; exit
1; } ||
:
526 news-date-check
: NEWS
527 today
=`date +%Y-%m-%d`; \
528 if head NEWS | grep
'^\*.* $(VERSION_REGEXP) ('$$today')' \
532 echo
"version or today's date is not in NEWS" 1>&2; \
537 if head ChangeLog | grep
'Version $(VERSION_REGEXP)\.$$' \
541 echo
"$(VERSION) not in ChangeLog" 1>&2; \
545 sc_makefile_TAB_only_indentation
:
546 @grep
-nE
'^ [ ]{8}' \
547 $$($(VC_LIST_EXCEPT
) | grep
-E
'akefile|\.mk$$') \
548 && { echo
'$(ME): found TAB-8-space indentation' 1>&2; \
552 @grep
-nE
'(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
553 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^configure\.ac|\.m4)$$') \
554 && { echo
'$(ME): quote the first arg to AC_DEF*' 1>&2; \
558 'you have changed the set of files with translatable diagnostics;\n\
559 apply the above patch\n'
561 # Verify that all source files using _() are listed in po/POTFILES.in.
562 po_file
= po
/POTFILES.in
564 @if
test -f
$(po_file
); then \
565 grep
-E
-v
'^(#|$$)' $(po_file
) \
566 | grep
-v
'^src/false\.c$$' |
sort > $@
-1; \
568 for file in
$$($(VC_LIST_EXCEPT
)) lib
/*.
[ch
]; do \
569 test -r
$$file || continue
; \
576 base
=`expr " $$file" : ' \(.*\)\..'`; \
577 { test -f
$$base.l ||
test -f
$$base.y
; } && continue
;; \
579 files
="$$files $$file"; \
581 grep
-E
-l
'\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
583 diff
-u
-L
$(po_file
) -L
$(po_file
) $@
-1 $@
-2 \
584 ||
{ printf
'$(ME): '$(fix_po_file_diag
) 1>&2; exit
1; }; \
588 # Sometimes it is useful to change the PATH environment variable
589 # in Makefiles. When doing so, it's better not to use the Unix-centric
590 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
591 msg
= '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
592 sc_makefile_path_separator_check
:
593 @grep
-nE
'PATH[=].*:' \
594 $$($(VC_LIST_EXCEPT
) | grep
-E
'akefile|\.mk$$') \
595 && { echo
$(msg
) 1>&2; exit
1; } ||
:
597 # Check that `make alpha' will not fail at the end of the process.
599 if
test -d
$(release_archive_dir
); then
:; else \
600 for file in
$(distdir
).
tar.gz \
601 $(release_archive_dir
)/$(distdir
).
tar.gz
; do \
602 test -e
$$file || continue
; \
604 ||
{ echo ERROR
: $$file is not writable
; fail
=1; }; \
606 test "$$fail" && exit
1 ||
: ; \
609 v_etc_file
= lib
/version-etc.c
610 sample-test
= tests
/sample-test
611 texi
= doc
/$(PACKAGE
).texi
612 # Make sure that the copyright date in $(v_etc_file) is up to date.
613 # Do the same for the $(sample-test) and the main doc/.texi file.
615 @if
test -f
$(v_etc_file
); then \
616 grep
'enum { COPYRIGHT_YEAR = '$$(date
+%Y
)' };' $(v_etc_file
) \
618 ||
{ echo
'out of date copyright in $(v_etc_file); update it' 1>&2; \
621 @if
test -f
$(sample-test
); then \
622 grep
'# Copyright (C) '$$(date
+%Y
)' Free' $(sample-test
) \
624 ||
{ echo
'out of date copyright in $(sample-test); update it' 1>&2; \
627 @if
test -f
$(texi
); then \
628 grep
'Copyright @copyright{} .*'$$(date
+%Y
)' Free' $(texi
) \
630 ||
{ echo
'out of date copyright in $(texi); update it' 1>&2; \
635 $(VC
) diff
> vc-diffs ||
:
636 if
test -s vc-diffs
; then \
638 echo
"Some files are locally modified:" 1>&2; \
644 cvs-check
: vc-diff-check
646 maintainer-distcheck
:
648 $(MAKE
) taint-distcheck
652 # Don't make a distribution if checks fail.
653 # Also, make sure the NEWS file is up-to-date.
654 vc-dist
: $(local-check
) cvs-check maintainer-distcheck
655 XZ_OPT
=-9ev
$(MAKE
) dist
657 # Use this to make sure we don't run these programs when building
658 # from a virgin tgz file, below.
659 null_AM_MAKEFLAGS
= \
666 built_programs
= $$(cd src
&& MAKEFLAGS
= $(MAKE
) -s built_programs.list
)
668 warn_cflags
= -Dlint
-O
-Werror
-Wall
-Wformat
-Wshadow
-Wpointer-arith
671 write_loser
= printf
'\#!%s\necho $$0: bad path 1>&2; exit 1\n' '$(SHELL)'
674 t
=$(TMPDIR
)/$(PACKAGE
)/test
677 # More than once, tainted build and source directory names would
678 # have caused at least one "make check" test to apply "chmod 700"
679 # to all directories under $HOME. Make sure it doesn't happen again.
680 tp
:= $(shell echo
"$(TMPDIR)/$(PACKAGE)-$$$$")
682 t_taint
= '$(t_prefix) b'
683 fake_home
= $(tp
)/home
685 # Ensure that tests run from tainted build and src dir names work,
686 # and don't affect anything in $HOME. Create witness files in $HOME,
687 # record their attributes, and build/test. Then ensure that the
688 # witnesses were not affected.
689 taint-distcheck
: $(DIST_ARCHIVES
)
690 test -d
$(t_taint
) && chmod
-R
700 $(t_taint
) ||
:
691 -rm -rf
$(t_taint
) $(fake_home
)
692 mkdir
-p
$(t_prefix
) $(t_taint
) $(fake_home
)
693 GZIP
=$(GZIP_ENV
) $(AMTAR
) -C
$(t_taint
) -zxf
$(distdir
).
tar.gz
694 mkfifo
$(fake_home
)/fifo
696 mkdir
-p
$(fake_home
)/d
/e
697 ls
-lR
$(fake_home
) $(t_prefix
) > $(tp
)/.ls-before
698 cd
$(t_taint
)/$(distdir
) \
701 && HOME
=$(fake_home
) $(MAKE
) check \
702 && ls
-lR
$(fake_home
) $(t_prefix
) > $(tp
)/.ls-after \
703 && diff
$(tp
)/.ls-before
$(tp
)/.ls-after \
704 && test -d
$(t_prefix
)
707 # Verify that a twisted use of --program-transform-name=PROGRAM works.
708 define install-transform-check
709 echo running install-transform-check \
711 && $(MAKE
) program_transform_name
='s/.*/zyx/' \
712 prefix=$(pfx
) install \
713 && test "$$(echo $(pfx)/bin/*)" = "$(pfx)/bin/zyx" \
714 && test "$$(find $(pfx)/share/man -type f|sed 's,.*/,,;s,\..*,,')" = "zyx"
717 # Install, then verify that all binaries and man pages are in place.
718 # Note that neither the binary, ginstall, nor the ].1 man page is installed.
720 $(MAKE
) prefix=$(pfx
) install \
721 && test ! -f
$(pfx
)/bin
/ginstall \
723 for i in
$(built_programs
); do \
724 test "$$i" = ginstall
&& i
=install; \
725 for j in
"$(pfx)/bin/$$i" \
726 "$(pfx)/share/man/man1/$$i.1"; do \
727 case
$$j in
*'[.1') continue
;; esac
; \
729 ||
{ echo
"$$j not installed"; fail
=1; }; \
732 test $$fail = 1 && exit
1 ||
:; \
736 define coreutils-path-check
738 if
test -f
$(srcdir)/src
/true.c
; then \
741 && ($(write_loser
)) > $(bin
)/loser \
742 && chmod a
+x
$(bin
)/loser \
743 && for i in
$(built_programs
); do \
745 rm|expr|
basename|echo|
sort|ls|tr
);; \
746 cat|dirname|mv|wc
);; \
747 *) ln
$(bin
)/loser
$(bin
)/$$i;; \
750 && ln
-sf ..
/src
/true
$(bin
)/false \
751 && PATH
=`pwd`/$(bin
)$(PATH_SEPARATOR
)$$PATH \
752 $(MAKE
) -C tests
check \
753 && { test -d gnulib-tests \
754 && $(MAKE
) -C gnulib-tests
check \
761 test $$fail = 1 && exit
1 ||
:; \
765 # Use -Wformat -Werror to detect format-string/arg-list mismatches.
766 # Also, check for shadowing problems with -Wshadow, and for pointer
767 # arithmetic problems with -Wpointer-arith.
768 # These CFLAGS are pretty strict. If you build this target, you probably
769 # have to have a recent version of gcc and glibc headers.
770 # The hard-linking for-loop below ensures that there is a bin/ directory
771 # full of all of the programs under test (except the ones that are required
772 # for basic Makefile rules), all symlinked to the just-built "false" program.
773 # This is to ensure that if ever a test neglects to make PATH include
774 # the build srcdir, these always-failing programs will run.
775 # Otherwise, it is too easy to test the wrong programs.
776 # Note that "false" itself is a symlink to true, so it too will malfunction.
777 my-distcheck
: $(DIST_ARCHIVES
) $(local-check
)
782 GZIP
=$(GZIP_ENV
) $(AMTAR
) -C
$(t
) -zxf
$(distdir
).
tar.gz
784 && .
/configure
--disable-nls \
785 && $(MAKE
) CFLAGS
='$(warn_cflags)' \
786 AM_MAKEFLAGS
='$(null_AM_MAKEFLAGS)' \
788 && $(install-transform-check
) \
790 && $(coreutils-path-check
) \
792 (cd
$(t
) && mv
$(distdir
) $(distdir
).old \
793 && $(AMTAR
) -zxf
- ) < $(distdir
).
tar.gz
794 diff
-ur
$(t
)/$(distdir
).old
$(t
)/$(distdir
)
796 @echo
"========================"; \
797 echo
"$(distdir).tar.gz is ready for distribution"; \
798 echo
"========================"
804 tarz
=/tmp
/rel-check-tarz-
$$$$; \
805 md5_tmp
=/tmp
/rel-check-md5-
$$$$; \
807 trap
'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
808 $(WGET
) $(WGETFLAGS
) -q
--output-document
=$$tarz $(url
); \
809 echo
"$(md5) -" > $$md5_tmp; \
810 md5sum
-c
$$md5_tmp < $$tarz
812 rel-files
= $(DIST_ARCHIVES
)
814 gnulib-version
= $$(cd
$(gnulib_dir
) && git describe
)
816 announcement
: NEWS ChangeLog
$(rel-files
)
817 @.
/build-aux
/announce-gen \
818 --release-type
=$(RELEASE_TYPE
) \
819 --package
=$(PACKAGE
) \
820 --prev
=$(PREV_VERSION
) \
822 --gpg-key-id
=$(gpg_key_ID
) \
824 --bootstrap-tools
=autoconf
,automake
,bison
,gnulib \
825 --gnulib-version
=$(gnulib-version
) \
826 --no-print-checksums \
827 $(addprefix --url-dir
=, $(url_dir_list
))
829 ## ---------------- ##
830 ## Updating files. ##
831 ## ---------------- ##
833 ftp-gnu
= ftp
://ftp.gnu.org
/gnu
834 www-gnu
= http
://www.gnu.org
836 # Use mv, if you don't have/want move-if-change.
837 move_if_change ?
= move-if-change
839 emit_upload_commands
:
840 @echo
=====================================
841 @echo
=====================================
842 @echo
"$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
843 @echo
" --to $(gnu_rel_host):$(PACKAGE) \\"
844 @echo
" $(rel-files)"
845 @echo
'# send the /tmp/announcement e-mail'
846 @echo
=====================================
847 @echo
=====================================
849 noteworthy
= * Noteworthy changes in release ?.?
(????
-??
-??
) [?
]
850 define emit-commit-log
851 printf
'%s\n' 'post-release administrivia' '' \
852 '* NEWS: Add header line for next release.' \
853 '* .prev-version: Record previous version.' \
854 '* cfg.mk (old_NEWS_hash): Auto-update.'
857 .PHONY
: alpha beta major
858 alpha beta major
: $(local-check
) writable-files
860 && { echo
$(VERSION
) | grep
-E
'^[0-9]+(\.[0-9]+)+$$' \
861 ||
{ echo
"invalid version string: $(VERSION)" 1>&2; exit
1;};}\
864 $(MAKE
) news-date-check
865 $(MAKE
) -s announcement RELEASE_TYPE
=$@
> /tmp
/announce-
$(my_distdir
)
866 if
test -d
$(release_archive_dir
); then \
867 ln
$(rel-files
) $(release_archive_dir
); \
868 chmod a-w
$(rel-files
); \
870 $(MAKE
) -s emit_upload_commands RELEASE_TYPE
=$@
871 echo
$(VERSION
) > $(prev_version_file
)
872 $(MAKE
) update-NEWS-hash
873 perl
-pi
-e
'$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
874 $(emit-commit-log
) > .ci-msg
875 $(VC
) commit
-F .ci-msg
-a
879 @
test -z
"$(manual_title)" \
880 && { echo
define manual_title in cfg.mk
1>&2; exit
1; } ||
:
881 @cd
'$(srcdir)/doc'; \
882 $(SHELL
) ..
/build-aux
/gendocs.sh
-o
'$(abs_builddir)/doc/manual' \
883 --email
$(PACKAGE_BUGREPORT
) $(PACKAGE
) \
884 "$(PACKAGE_NAME) - $(manual_title)"
885 @echo
" *** Upload the doc/manual directory to web-cvs."